<?php

namespace FiloBlu\PageSpeedOptimizer\Observer;

use Magento\Framework\Event\ObserverInterface;

class RemoveScripts implements ObserverInterface
{

    public $helper;
    

    public function __construct(\FiloBlu\PageSpeedOptimizer\Helper\Data $helper)
    {
        $this->helper = $helper;
    }
    
    /**
     * @param \Magento\Framework\Event\Observer $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {

        if ($this->helper->isEnabled()) {
            $response = $observer->getEvent()->getResponse();
            $html     = $response->getBody();

            /*$doc = new \DOMDocument();

            // load the HTML string we want to strip
            $doc->loadHTML($html);

            // get all the script tags
            $script_tags = $doc->getElementsByTagName('script');

            $length = $script_tags->length;

            // for each tag, remove it from the DOM
            for ($i = 0; $i < $length; $i++) {
                $script_tags->item($i)->parentNode->removeChild($script_tags->item($i));
            }

            // get the HTML string back
            $no_script_html_string = $doc->saveHTML();*/

            $no_script_html_string = preg_replace('#<script(.*?)>(.*?)</script>#is', '', $html);

            $response->setBody(
                $no_script_html_string
            );
        }
        

    }
}
